package cn.com.infosec.asn1;

import java.io.ByteArrayOutputStream;
import java.io.IOException;

public class DERUniversalString extends ASN1Object implements DERString {
   private static final char[] table = new char[]{'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'};
   private byte[] string;

   public static DERUniversalString getInstance(Object obj) {
      if (obj != null && !(obj instanceof DERUniversalString)) {
         if (obj instanceof ASN1OctetString) {
            return new DERUniversalString(((ASN1OctetString)obj).getOctets());
         } else {
            throw new IllegalArgumentException("illegal object in getInstance: " + obj.getClass().getName());
         }
      } else {
         return (DERUniversalString)obj;
      }
   }

   public static DERUniversalString getInstance(ASN1TaggedObject obj, boolean explicit) {
      return getInstance(obj.getObject());
   }

   public DERUniversalString(byte[] string) {
      this.string = string;
   }

   public String getString() {
      StringBuffer var1;
      var1 = new StringBuffer.<init>("#");
      ByteArrayOutputStream var2;
      ByteArrayOutputStream var10000 = var2 = new ByteArrayOutputStream;
      var10000.<init>();
      DERUniversalString var10002 = this;
      ASN1OutputStream var10001 = new ASN1OutputStream(var2);

      try {
         var10001.writeObject(var10002);
      } catch (IOException var4) {
         throw new RuntimeException("internal error encoding BitString");
      }

      byte[] var5 = var10000.toByteArray();

      for(int var6 = 0; var6 != var5.length; ++var6) {
         char[] var3;
         char[] var7 = var3 = table;
         var1.append(var3[var5[var6] >>> 4 & 15]);
         var1.append(var7[var5[var6] & 15]);
      }

      return var1.toString();
   }

   public String toString() {
      return this.getString();
   }

   public byte[] getOctets() {
      return this.string;
   }

   void encode(DEROutputStream out) {
      out.writeEncoded(28, this.getOctets());
   }

   boolean asn1Equals(DERObject o) {
      return !(o instanceof DERUniversalString) ? false : this.getString().equals(((DERUniversalString)o).getString());
   }

   public int hashCode() {
      return this.getString().hashCode();
   }
}
